<?php
/**
 * @package Google Maps
 * @author Huge-IT
 * @copyright (C) 2014 Huge IT. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @website		http://www.huge-it.com/
 **/

defined('_JEXEC') or die;
jimport('joomla.application.component.modeladmin');
jimport('joomla.application.component.helper');

class GooglemapsModelGooglemap extends JModelAdmin {

    public function getTable($type = 'Googlemap', $prefix = 'GooglemapsTable', $config = array()) {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function getForm($data = array(), $loadData = true) {

        $form = $this->loadForm(
                $this->option . '.googlemaps', 'googlemaps', array('control' => 'jform', 'load_data' => $loadData)
        );

        if (empty($form)) {
            return false;
        }

        return $form;
    }

    protected function loadFormData() {
        $data = JFactory::getApplication()->getUserState($this->option . '.editgooglemaps.data', array());
        if (empty($data)) {
            $data = $this->getItem();
        }
        return $data;
    }

    public function getMap() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_maps');
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }
    
     public function getMarker() {
        $db = JFactory::getDBO();
        $id_cat = JRequest::getVar('id');
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_markers');
        $query->where('map=' . $id_cat);
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getPropertie() {
        $db = JFactory::getDBO();
        $id_cat = JRequest::getVar('id');
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_maps');
        $query->where('id=' . $id_cat);
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }

    
      public function getPolygones() {
        $db = JFactory::getDBO();
        $id_cat = JRequest::getVar('id');
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_polygones');
        $query->where('map=' . $id_cat);
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }

      public function getPolylines() {
        $db = JFactory::getDBO();
        $id_cat = JRequest::getVar('id');
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_polylines');
        $query->where('map=' . $id_cat);
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }
    
    
     public function getCircles() {
        $db = JFactory::getDBO();
        $id_cat = JRequest::getVar('id');
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_circles');
        $query->where('map=' . $id_cat);
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
    }
    
    
    public function ajax() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('*');
        $query->from('#__g_maps');
        $db->setQuery($query);
        $results = $db->loadObjectList();
        return $results;
        
    }
  
    public function saveMap() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->insert('#__g_maps', 'id')
                ->set('name = "New Map"')
                ->set('type = "ROADMAP"')
                ->set('zoom = 2')
                ->set('center_lat = 0')
                ->set('center_lng = 0')
                ->set('language="location based"')
                ->set('animation = "none"');
        $db->setQuery($query);
        $db->execute();
        return $db->insertid();
    }
    
    public function add() {
        $db = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->insert('#__g_maps', 'id')
                ->set('name = "New Map"')
                ->set('type = "ROADMAP"')
                ->set('zoom = 2')
                ->set('center_lat = 0')
                ->set('center_lng = 0')
                ->set('language="location based"')
                ->set('animation = "none"');
        $db->setQuery($query);
        $db->execute();
        return $db->insertid();
    }
     public function copy() {
        $db = JFactory::getDBO();
        $mapElements = $this->getPropertie();
        $markerElements = $this->getmarker();
        $polygonelement = $this->getPolygones();
        $polylineelements = $this->getPolylines();
        $circleElements = $this->getCircles();
         
        foreach ($mapElements as $map_element){
            $mapId = ($map_element->id != null)? $mapId = $map_element->id : $mapId=0;
            $mapName =($map_element->name != null) ? $mapName = $map_element->name :$mapName='' ;
            $mapType = ($map_element->type != null) ? $mapType = $map_element->type : $mapType = 'ROADMAP';
            $mapWidth = ($map_element->width != null) ? $mapWidth = $map_element->width : $mapWidth = 0;
            $mapHeight = ($map_element->height != null ) ? $mapHeight = $map_element->height : $mapHeight = 0;
            $mapZoom = ($map_element->zoom != null) ? $mapZoom = $map_element->zoom : $mapZoom = 2 ;
            $mapAlign = ($map_element->align != null) ? $mapAlign = $map_element -> align : $mapAlign = 'left' ;
            $mapBorderRadius = ($map_element->border_radius != null) ? $mapBorderRadius = $map_element->border_radius: $mapBorderRadius = 0;
            $mapCenterLat = ($map_element->center_lat != null) ? $mapCenterLat = $map_element->center_lat : $mapCenterLat = 0;
            $mapCenterLng = ($map_element->center_lng != null) ? $mapCenterLng = $map_element->center_lng : $mapCenterLng = 0;
            $mapPanController = ($map_element->pan_controller != null ) ? $mapPanController = $map_element->pan_controller : $mapPanController = 'true';
            $mapTypeController = ($map_element->type_controller != null) ? $mapTypeController = $map_element->type_controller : $mapTypeController = 'true';
            $mapScaleController = ($map_element->scale_controller != null) ? $mapScaleController = $map_element->scale_controller : $mapScaleController = 'true';
            $mapStreetViewController = ($map_element->street_view_controller != null) ? $mapStreetViewController = $map_element->street_view_controller : $mapStreetViewController = 'true';
            $mapInfoType = ($map_element->info_type != null) ? $mapInfoType = $map_element->info_type : $mapInfoType= 'click';
            $mapZoomController = ($map_element->zoom_controller != null) ?  $mapZoomController = $map_element->zoom_controller : $mapZoomController = 'true';
            $mapOverview = ($map_element->overview_map_controller != null) ? $mapOverview = $map_element->overview_map_controller : $mapOverview = 'true';
            $mapwheel_scroll =  ($map_element -> wheel_scroll != null) ? $mapwheel_scroll = $map_element -> wheel_scroll : $mapwheel_scroll = 'true';
            $mapDraggable = ($map_element -> draggable != null) ? $mapDraggable = $map_element -> draggable : $mapDraggable= 'true';
            $mapLanguage = ($map_element -> language != null) ? $mapLanguage = $map_element -> language : $mapLanguage = 'location based';
            $mapMin_zoom = ($map_element -> min_zoom != null) ?  $mapMin_zoom = $map_element -> min_zoom : $mapMin_zoom = 0;
            $mapMax_zoom = ($map_element ->max_zoom != null) ? $mapMax_zoom = $map_element ->max_zoom : $mapMax_zoom = 10;
            $mapAnimation = ($map_element -> animation != null) ? $mapAnimation = $map_element -> animation : $mapAnimation = 'none';
            $mapStyling_hue  = ($map_element ->styling_hue != null) ? $mapStyling_hue = $map_element ->styling_hue: $mapStyling_hue = '';
            $mapStyling_saturation = ($map_element -> styling_saturation != null) ? $mapStyling_saturation = $map_element -> styling_saturation : $mapStyling_saturation = 0;
            $mapStyling_lightness = ($map_element -> styling_lightness != null) ? $mapStyling_lightness = $map_element -> styling_lightness: $mapStyling_lightness = 0;
            $mapStyling_gamma = ($map_element -> styling_gamma != null ) ? $mapStyling_gamma = $map_element -> styling_gamma : $mapStyling_gamma = 1;
            $mapBike_layer = ($map_element -> bike_layer != null) ? $mapBike_layer = $map_element -> bike_layer : $mapBike_layer = 'false' ;
            $mapTraffic_layer = ($map_element -> traffic_layer != null) ? $mapTraffic_layer = $map_element -> traffic_layer : $mapTraffic_layer = 'false';
            $maptransit_layer = ($map_element  -> transit_layer != null) ? $maptransit_layer = $map_element  -> transit_layer : $maptransit_layer = 'false';
          }
          
       
        $query = $db->getQuery(true);
        $query->insert('#__g_maps', 'id')
                ->set('name ='."'$mapName'")
                ->set('type = '."'$mapType'")
                ->set('width = '."'$mapWidth'")
                ->set('height ='."'$mapHeight'")
                ->set('zoom = '."'$mapZoom'")
                ->set('align='."'$mapAlign'")
                ->set('border_radius = '."'$mapBorderRadius'")
                ->set('center_lat='."'$mapCenterLat'")
                ->set('center_lng='."'$mapCenterLng'")
                ->set('pan_controller='."'$mapPanController'")
                ->set('type_controller='."'$mapTypeController'")
                ->set('scale_controller='."'$mapScaleController'")
                ->set('street_view_controller='."'$mapStreetViewController'")
                ->set('info_type='."'$mapInfoType'")
                ->set('zoom_controller='."'$mapZoomController'")
                ->set('overview_map_controller='."'$mapOverview'")
                ->set('wheel_scroll='."'$mapwheel_scroll'")
                ->set('draggable='."'$mapDraggable'")
                ->set('language='."'$mapLanguage'")
                ->set('min_zoom='."'$mapMin_zoom'")
                ->set('max_zoom='."'$mapMax_zoom'")
                ->set('animation='."'$mapAnimation'")
                ->set('styling_hue='."'$mapStyling_hue'")
                ->set('styling_saturation='."'$mapStyling_saturation'")
                ->set('styling_lightness='."'$mapStyling_lightness'")
                ->set('bike_layer='."'$mapBike_layer'")
                ->set('traffic_layer='."'$mapTraffic_layer'")
                ->set('transit_layer='."'$maptransit_layer'");
                $db->setQuery($query);
                $db->execute();
                $last_id = mysql_insert_id();
                
              
        foreach ($markerElements as $marker) {
            $markerId  = $marker -> id;
            $markerMap = ($marker -> map != null);
            $markerTitle = $marker -> title;
            $markerLat =  $marker -> lat;
            $markerLng =  $marker ->  lng;
            $markerAnimation = $marker -> animation;
            $markerDescription = $marker -> description;
            $markerImg = $marker -> img;
            $markerSize = $marker -> size;
        }
                
            $queryMarker = $db->getQuery(true);
            if(!empty($markerElements)) {
            $queryMarker->insert('#__g_markers', 'id')
            ->set('map ='."'$last_id'")
            ->set('title = '."'$markerTitle'")
            ->set('lat = '."'$markerLat'")
            ->set('lng ='."'$markerLng'")
            ->set('animation = '."'$markerAnimation'")
            ->set('description='."'$markerDescription'")
            ->set('img = '."'$markerImg'")
            ->set('size='."'$markerSize'");
            $db->setQuery($queryMarker);
            $db->execute();
            }
      
    foreach ($polygonelement as $polygone) {
        $polygonId = $polygone -> id;
        $polygoneMap = $polygone -> map;
        $polygoneName = $polygone -> name;
        $polygoneData = $polygone -> data;
        $polygoneLineOpacity = $polygone ->line_opacity;
        $polygoneLineColor = $polygone -> line_color;
        $polygoneFillOpacity = $polygone -> fill_opacity;
        $polyogoneFillColor = $polygone -> fill_color;
        $polygoneUrl = $polygone -> url;
        $polygoneHoverLineOpacity = $polygone -> hover_line_opacity;
        $polygoneHoverLineColor = $polygone -> hover_line_color;
        $polygonehoverFillOacity = $polygone -> hover_fill_opacity;
        $polygoneHoverFiColor = $polygone -> hover_fill_color;
        $polygoneLineWidth = $polygone -> line_width;
    }

    if(!empty($polygonelement)) {
        $queryPolygone = $db->getQuery(true);
        $queryPolygone -> insert('#__g_polygones')
            ->set('map="'.$last_id.'"')
            ->set('name="'.$polygoneName.'"')
            ->set('data="'.$polygoneData.'"')
            ->set('line_opacity="'.$polygoneLineOpacity.'"')
            ->set('line_color ="'.$polygoneLineColor.'"')
            ->set('fill_opacity="'.$polygoneFillOpacity.'"')
            ->set('fill_color="'.$polyogoneFillColor.'"')
            ->set('url="'.$polygoneUrl.'"')
            ->set('hover_line_opacity="'.$polygoneHoverLineOpacity.'"')
            ->set('hover_line_color="'.$polygoneHoverLineColor.'"')
            ->set('hover_fill_opacity="'.$polygonehoverFillOacity.'"')
            ->set('hover_fill_color="'.$polygoneHoverFiColor.'"')
            ->set('line_width="'.$polygoneLineWidth.'"');
        
        $db->setQuery($queryPolygone);
        $db->execute();
        }
    foreach ($polylineelements as $polyline) {
        $polylineId = $polyline -> id;
        $polylineMap = $polyline -> map;
        $polyline_name = $polyline -> name;
        $polyline_coords = $polyline -> data;
        $polyline_line_opacity = $polyline -> line_opacity;
        $polyline_line_color = $polyline -> line_color;
        $hover_polyline_line_opacity = $polyline -> line_width;
        $hover_polyline_line_color = $polyline -> hover_line_color;
        $polyline_line_width = $polyline -> hover_line_opacity;
    }

    if(!empty($polylineelements)) {
        $queryPolyline = $db->getQuery(true);
        $queryPolyline -> insert('#__g_polylines')
            ->set('map="'.$last_id.'"')
            ->set('name="'.$polyline_name.'"')
            ->set('data="'.$polyline_coords.'"')
            ->set('line_opacity="'.$polyline_line_opacity.'"')
            ->set('line_color ="'.$polyline_line_color.'"')
            ->set('hover_line_opacity="'.$hover_polyline_line_opacity.'"')
            ->set('hover_line_color="'.$hover_polyline_line_color.'"')
            ->set('line_width="'.$polyline_line_width.'"');
        $db->setQuery($queryPolyline);
        $db->execute();
}

    foreach ($circleElements as $circle) {
        $circle_map = $circle -> map;
        $circle_name= $circle -> name;
        $circle_center_lat= $circle -> center_lat;
        $circle_center_lng= $circle -> center_lng;
        $circle_radius= $circle -> radius;
        $circle_line_width= $circle -> line_width;
        $circle_line_opacity= $circle -> line_opacity;
        $circle_line_color= $circle -> line_color;
        $circle_fill_color= $circle -> fill_color;
        $circle_fill_opacity= $circle -> fill_opacity;
        $circle_hover_line_opacity= $circle -> hover_line_opacity;
        $circle_hover_line_color= $circle -> hover_line_color;
        $circle_hover_fill_color= $circle -> hover_fill_color;
        $circle_hover_fill_opacity= $circle -> hover_fill_opacity;
        $circle_show_marker= $circle -> show_marker;
}


if(!empty($circleElements)) {
    $queryCircle = $db->getQuery(true);
    $queryCircle -> insert('#__g_circles')
        ->set('map="'.$last_id.'"')
        ->set('name="'.$circle_name.'"')
        ->set('center_lat="'.$circle_center_lat.'"')
        ->set('center_lng="'.$circle_center_lng.'"')
        ->set('radius="'.$circle_radius.'"')
        ->set('line_width="'.$circle_line_width.'"')
        ->set('line_opacity="'.$circle_line_opacity.'"')
        ->set('line_color ="'.$circle_line_color.'"')
        ->set('fill_opacity="'.$circle_fill_opacity.'"')
        ->set('fill_color="'.$circle_fill_color.'"')
        ->set('hover_line_color="'.$circle_hover_line_color.'"')
        ->set('hover_line_opacity="'.$circle_hover_line_opacity.'"')
        ->set('hover_fill_opacity="'.$circle_hover_fill_opacity.'"')
        ->set('hover_fill_color="'.$circle_hover_fill_color.'"')
        ->set('show_marker="'.$circle_show_marker.'"');
        $db->setQuery($queryCircle);
        $db->execute();
}
    return $last_id;
}
     
}
