<?php
/**
 * @package Google Maps
 * @author Huge-IT
 * @copyright (C) 2014 Huge IT. All rights reserved.
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * @website		http://www.huge-it.com/
 **/
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

class GooglemapsViewAjax extends JViewLegacy {

    protected $item;
    protected $mapParams;
    protected $form;
    protected $generalOption;
    protected $Marker;
    protected $polylines;
    protected $Circles;
    protected $Poligon;

    public function display($tpl = null) {
        try {
            $response = "<?xml version='1.0' encoding='UTF-8'?>
                <maps>";
            $this->generalOption = $this->get('GeneralOption');
            foreach ($this->generalOption as $mapinfo) {
                $response = $response . "<map name='" . $this->parseToXML($mapinfo->name) . "' info_type='" . $mapinfo->info_type . "' pan_controller='" . $mapinfo->pan_controller . "' zoom_controller='" . $mapinfo->zoom_controller . "' type_controller='" . $mapinfo->type_controller . "' scale_controller='" . $mapinfo->scale_controller . "' street_view_controller='" . $mapinfo->street_view_controller . "' overview_map_controller='" . $mapinfo->overview_map_controller . "' type='" . $mapinfo->type . "' zoom='" . $mapinfo->zoom . "' center_lat='" . $mapinfo->center_lat . "' center_lng='" . $mapinfo->center_lng . "'  />";
            }
            $this->Marker = $this->get('Marker');
            foreach ($this->Marker as $marker) {
                $response = $response . "<marker id='" . $marker->id . "' size='" . $marker->size . "' name='" . $marker->title . "' animation='" . $marker->animation . "' lat='" . $marker->lat . "' lng='" . $marker->lng . "' description='" . $this->parseToXML($marker->description) . "' img='" . $marker->img . "' />";
            }
            $this->Poligon = $this->get('Poligon');
            foreach ($this->Poligon as $polygone) {
                $response = $response . "<polygone id='" . $polygone->id . "' name='" . $this->parseToXML($polygone->name) . "'  url='" . $polygone->url . "' line_width='" . $polygone->line_width . "'  line_opacity='" . $polygone->line_opacity . "' line_color='" . $polygone->line_color . "' fill_opacity='" . $polygone->fill_opacity . "' fill_color='" . $polygone->fill_color . "' hover_line_color='" . $polygone->hover_line_color . "' hover_line_opacity='" . $polygone->hover_line_opacity . "' hover_fill_color='" . $polygone->hover_fill_color . "' hover_fill_opacity='" . $polygone->hover_fill_opacity . "' >";
                preg_match_all('/\(([^\)]*)\)/', $polygone->data, $matches);
                    foreach ($matches[1] as $latlng) {
                       preg_match_all("/[^,]+[\d+][.?][\d+]*/", $latlng, $results);
                      // print_r($results);
                        foreach ($results as $latlng) {
                        $response = $response . "<latlng lat='" . $latlng[0] . "' lng='" . $latlng[1] . "' />";
                    }
                }
                $response = $response . "</polygone>";
            }
            $this->polylines = $this->get('Polylines');
            foreach ($this->polylines as $polyline){  
                $response = $response . "<polyline id='" . $polyline->id . "' name='" . $this->parseToXML($polyline->name) . "' hover_line_color='" . $polyline->hover_line_color . "' hover_line_opacity='" . $polyline->hover_line_opacity . "' line_opacity='" . $polyline->line_opacity . "' line_color='" . $polyline->line_color . "' line_width='" . $polyline->line_width . "' >";
                preg_match_all('/\(([^\)]*)\)/', $polyline->data, $matches);
                foreach ($matches[1] as $latlng) {
                    preg_match_all("/[^,]+[\d+][.?][\d+]*/", $latlng, $results);
                    foreach ($results as $latlng) {
                        $response = $response . "<latlng lat='" . $latlng[0] . "' lng='" . $latlng[1] . "' />llll";
                    }
                }
                $response = $response."</polyline>";
            }
            $this->Circles = $this->get('Circles');
            foreach ($this->Circles as $circle) {
                $response = $response . "<circle id='" . $circle->id . "' name='" . $this->parseToXML($circle->name) . "' center_lat='" . $circle->center_lat . "' center_lng='" . $circle->center_lng . "' radius='" . $circle->radius . "' hover_fill_color='" . $circle->hover_fill_color . "' hover_fill_opacity='" . $circle->hover_fill_opacity . "' hover_line_color='" . $circle->hover_line_color . "' hover_line_opacity='" . $circle->hover_line_opacity . "' line_width='" . $circle->line_width . "' line_color='" . $circle->line_color . "' line_opacity='" . $circle->line_opacity . "' fill_color='" . $circle->fill_color . "' fill_opacity='" . $circle->fill_opacity . "' show_marker='" . $circle->show_marker . "' />";
            }




            $response = $response . "</maps>";

            $response1["success"] = $response;
            echo json_encode($response1);
            jexit();
        } catch (Exception $e) {
            throw new Exception($e->getMessage());
        }
    }
    
    
    function parseToXML($htmlStr) {
        $xmlStr=str_replace('<','&lt;',$htmlStr);
        $xmlStr=str_replace('>','&gt;',$xmlStr);
        $xmlStr=str_replace('\"','&quot;',$xmlStr);
        $xmlStr=str_replace("\'",'&#39;',$xmlStr);
        $xmlStr=str_replace("&",'&amp;',$xmlStr);
        return $xmlStr;
	}

}
